#include <iostream>
#include <fstream>
// Programa de multiplicacion de dos matrices
using namespace std;

float **
matmult(float **const m1, float **const m2, int nn, int nm, int nq)
{
  float          ** matprod = new float *[nm];
  for (int i = 0; i < nm; i++)
    matprod[i] = new float[nq];
  for (int i = 0; i < nm; i++) {
    for (int j = 0; j < nq; j++) {
      matprod[i][j] = 0;
      for (int k = 0; k < nn; k++)
        matprod[i][j] += m1[i][k] * m2[k][j];
    }
  }
  return matprod;
}

int 
main()
{
  // fichero de entrada
  ifstream fin("mat1.dat");
  // fichero de salida
  ofstream fout("matmult1.dat");
  //definicion  de dimensiones
  int             n, m, p, q;
  // lectura de dimensiones y elementos de matrices y posterior escritura
  // en pantalla
  fin >> m >> n;
  float         **const mat1 = new float *[m]; //mat1 apunta a direccion constante
    for (int i = 0; i < m; i++)
    mat1[i] = new float[n];
  for (int i = 0; i < m; i++)
    for (int j = 0; j < n; j++)
      fin >> mat1[i][j];
  fin >> p >> q;
  float         **const mat2 = new float *[p];
  // mat2 apunta a direccion constante
    for (int i = 0; i < p; i++)
    mat2[i] = new float[q];
  for (int i = 0; i < p; i++) {
    for (int j = 0; j < q; j++)
      fin >> mat2[i][j];
  }
    float         **mat3 = new float *[m];
  for (int i = 0; i < m; i++)
    mat3[i] = new float[q];
  // Comprobacion de compatibilidad de dimensiones
    if (n != p) {
    cout << " Dimensiones incorrectas. No se pueden multiplicar las matrices" << endl;
    return 0;
  }
  // Multiplicacion de matrices
  mat3 = matmult(mat1, mat2, n, m, q);
  // Impresion del resultado en fichero
  for (int i = 0; i < m; i++) {
    for (int j = 0; j < q; j++) {
      fout << mat3[i][j] << "   ";
    }
    fout << endl;
  }
  fin.close();
  fout.close();
  return 0;
}
