  
  /**
   *  Addition.
   */
  friend mp_int operator+(const mp_int& ja, const mp_int& jb);
  
  /**
   *  Subtraction.
   */
  friend mp_int operator-(const mp_int& ja, const mp_int& jb);
  
  /**
   *  Negation.
   */
  friend mp_int operator-(const mp_int& ja);
  
  /**
   *  Multiplication.
   */
  friend mp_int operator*(const mp_int& ja, const mp_int& jb);
  
  /**
   *  Division.
   */
  friend mp_int operator/(const mp_int& ja, const mp_int& jb);
  
  /**
   *  Remainder.
   */
  friend mp_int operator%(const mp_int&, const mp_int&);
  

 /**
   *  Absolute value.
   */
  friend mp_int abs(const mp_int&);
  
  /**
   *  Maximum.
   */  
  friend mp_int maximum(const mp_int&, const mp_int&);
  
  /**
   *  Minimum.
   */
  friend mp_int minimum(const mp_int&, const mp_int&);
  
  /**
   *  FORTRAN's sign operator.
   *  @return The absolute value of first parameter with sign of 
   *  second parameter.
   */
  friend mp_int sign(const mp_int&, const mp_int&);
  
  /**
   *  Power.
   */
  friend mp_int power(const mp_int&, const mp_int&);
  
  /**
   *  Power.
   */
  friend mp_int power(const int, const mp_int&);
  
  /**
   *  Power.
   */
  friend mp_int power(const mp_int&, const int);
























