// Ejemplos con TNT
// compilar con  g++ - I./templates -o tnt_ejemplos  tnt_ejemplos.cpp
#include <cmath>
#include <iostream>
#include "algebralineal.h"
using namespace std;
using namespace CALNUM;

int main()
{
  int             n; //dimension, que puede ser leida en ejecucion
  cout << "Entrar dimension" << endl;
  cin >> n;

  //Ejemplos con vectores

  Vector < double >a(n); //Construccion de vectores
  Vector < double >b(n), c(n);
  for (int i = 0; i < n; i++)
    a[i] = i; //Relleno de vector a
  b = 2.;  //inicializacion:todos los elemtos = 2
  cout << "a= " << a << "b= " << b << endl;
  c = a + b; //suma de vectores
  cout<<"c=a+b= "<<c<<endl;
  c+=a;    //sobtrcarga +=
  cout<<"c+=a= "<<c<<endl;
  c-=a;
  cout<<"c-=a= "<<c<<endl;
  c*=n;
  cout<<"c*=n = "<<c<<endl;
  c/=n;
  cout<<"c/=n = "<<c<<endl;
  c=a%b;
  cout<<"c=a%b="<<c<<endl;
  
  cout<< "norma de c = "<<norm (c) <<endl; //norma del vector
  
  double          s = a * b;  //producto escalar de a y b
  double          d = dot_prod(a, b); //otra forma de producto escalar
  
  cout << "producto escalar= " << s << endl;
  cout << d << endl; //impresion de vectores
  double          x = 5.;
  //productos de un escalar por un vector a la derecha y a la izquierda
  cout << "c= " << c << endl; //impresion vector c
  c = c * x;
  cout << "c*x =" << c << endl;
  c = x * c;
  cout << "c= " << c << endl;

  //Ejempos con matrices y vectores
  
  //Construccion de tres matrices de double
  Matrix < double >A(n, n), B(n, n), C(n, n); 
  for(int i = 0; i < n; i++)
    A[i][i] = double (i); //relleno de la matriz A
  B = 1.; //todos los elemtos de B = 1.
  
  //Sobrecarga += para matrices
  A += B;
  cout<< "A+=B "<< A<<endl;
  
 
  //Sobrecarga -= para matrices
  A -= B;
  cout<< "A-=B ="<<A<<endl;
   
  
  //Sobrecarca *= para matrices
  A *= B;
  cout<<"A*=B ="<<A<<endl;
  
  //Sobrecarga *= Matrices y escalares
  A*=x;
  cout<<"A*=x ="<<A<<endl;
  
  //Sobrecarga /= Matrices y escalares
  A/=x;
  cout<<"A/=x ="<<A<<endl;
    
 //Sobrecarga * para matrices 
 C = A * B; //multiplicacion de matrices
 cout << C << endl; //impresion matriz C
  
  C = C + A - B; //Suma y resta de matrices
  A = transpose(C); //transpuesta de una matriz
  
  c = B * b; //producto de una matriz por un vector
  cout << "B= " << B << " b= " << b << " c=B*b= " << c << endl;
  
  C = B * x;//Producto de una matriz por un escalar
  cout<<"C= B*x= "<<C<<endl;

  B= C/x; // Division de una matriz por un escalar
  cout<<"C/x= "<<B<<endl;
  double tr=spur(B);
  cout<< "Traza de B=C/x= "<< tr <<endl; //traza
    
  cout << "A= " << A << "c= " << c << "x= " << x << endl;
  c = x * A * c * x; //producto de un escalar por matriz por vector por escalar
  cout << " c=x*A*c*x= " << c << endl;
}
