#ifndef MACROS_H
#define MACROS_H

#ifndef DEFINITIONS_H
#error definition.h has to be include before including this file.
#else
#if MVC == 1
#define MUTEX_LOCK() cs.Lock()
#define MUTEX_UNLOCK() cs.Unlock()
#else
#define MUTEX_LOCK() 
#define MUTEX_UNLOCK()
#endif

#define MAX(x,y) ( (x)>=(y) ? (x) : (y) )
#define MIN(x,y) ( (x)>=(y) ? (y) : (x) )
#define MIN3(x,y,z) ( MIN((x), MIN((y), (z))) )
#define NINT(x) ( (x)<0 ? ceil((x) - .5) : floor((x) + .5) )

#endif
#endif

